diff --git a/doc/bash.0 b/doc/bash.0
index 7f6504aa..c5b9026a 100644
--- a/doc/bash.0
+++ b/doc/bash.0
@@ -6043,8 +6043,8 @@ SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS
               _n_a_m_e will be unset rather than the variable it  references.   --nn
               has  no  effect if the --ff option is supplied.  If no options are
               supplied, each _n_a_m_e refers to a variable; if there is  no  vari-
-              able  by  that name, any function with that name is unset.  Each
-              unset variable or  function  is  removed  from  the  environment
+              able  by that name, a function with that name, if any, is unset.
+              Each unset variable or function is removed from the  environment
               passed   to   subsequent  commands.   If  any  of  BBAASSHH__AALLIIAASSEESS,
               BBAASSHH__AARRGGVV00,  BBAASSHH__CCMMDDSS,  BBAASSHH__CCOOMMMMAANNDD,  BBAASSHH__SSUUBBSSHHEELLLL,  BBAASSHHPPIIDD,
               CCOOMMPP__WWOORRDDBBRREEAAKKSS,  DDIIRRSSTTAACCKK,  EEPPOOCCHHRREEAALLTTIIMMEE,  EEPPOOCCHHSSEECCOONNDDSS, FFUUNNCC--
diff --git a/doc/bash.info b/doc/bash.info
index c55464c9..89d92e50 100644
--- a/doc/bash.info
+++ b/doc/bash.info
@@ -3332,9 +3332,9 @@ standard.
      attribute, NAME will be unset rather than the variable it
      references.  '-n' has no effect if the '-f' option is supplied.  If
      no options are supplied, each NAME refers to a variable; if there
-     is no variable by that name, any function with that name is unset.
-     Readonly variables and functions may not be unset.  Some shell
-     variables lose their special behavior if they are unset; such
+     is no variable by that name, a function with that name, if any, is
+     unset.  Readonly variables and functions may not be unset.  Some
+     shell variables lose their special behavior if they are unset; such
      behavior is noted in the description of the individual variables.
      The return status is zero unless a NAME is readonly.
 
@@ -3884,7 +3884,7 @@ standard.
           from regular files.  If 'read' times out, 'read' saves any
           partial input read into the specified variable NAME.  If
           TIMEOUT is 0, 'read' returns immediately, without trying to
-          read and data.  The exit status is 0 if input is available on
+          read any data.  The exit status is 0 if input is available on
           the specified file descriptor, non-zero otherwise.  The exit
           status is greater than 128 if the timeout is exceeded.
 
@@ -9335,7 +9335,7 @@ history file.
 
      In the second form, COMMAND is re-executed after each instance of
      PAT in the selected command is replaced by REP.  COMMAND is
-     intepreted the same as FIRST above.
+     interpreted the same as FIRST above.
 
      A useful alias to use with the 'fc' command is 'r='fc -s'', so that
      typing 'r cc' runs the last command beginning with 'cc' and typing
@@ -11822,84 +11822,84 @@ Node: Signals119037
 Node: Shell Scripts121004
 Node: Shell Builtin Commands124016
 Node: Bourne Shell Builtins126054
-Node: Bash Builtins146970
-Node: Modifying Shell Behavior175895
-Node: The Set Builtin176240
-Node: The Shopt Builtin186653
-Node: Special Builtins204323
-Node: Shell Variables205302
-Node: Bourne Shell Variables205739
-Node: Bash Variables207843
-Node: Bash Features239785
-Node: Invoking Bash240684
-Node: Bash Startup Files246697
-Node: Interactive Shells251800
-Node: What is an Interactive Shell?252210
-Node: Is this Shell Interactive?252859
-Node: Interactive Shell Behavior253674
-Node: Bash Conditional Expressions257161
-Node: Shell Arithmetic261738
-Node: Aliases264678
-Node: Arrays267298
-Node: The Directory Stack272663
-Node: Directory Stack Builtins273447
-Node: Controlling the Prompt276415
-Node: The Restricted Shell279336
-Node: Bash POSIX Mode281818
-Node: Job Control292751
-Node: Job Control Basics293211
-Node: Job Control Builtins298175
-Node: Job Control Variables303321
-Node: Command Line Editing304477
-Node: Introduction and Notation306148
-Node: Readline Interaction307771
-Node: Readline Bare Essentials308962
-Node: Readline Movement Commands310745
-Node: Readline Killing Commands311705
-Node: Readline Arguments313623
-Node: Searching314667
-Node: Readline Init File316853
-Node: Readline Init File Syntax318112
-Node: Conditional Init Constructs338642
-Node: Sample Init File342838
-Node: Bindable Readline Commands345955
-Node: Commands For Moving347159
-Node: Commands For History349018
-Node: Commands For Text353313
-Node: Commands For Killing356701
-Node: Numeric Arguments359516
-Node: Commands For Completion360655
-Node: Keyboard Macros364846
-Node: Miscellaneous Commands365533
-Node: Readline vi Mode371486
-Node: Programmable Completion372393
-Node: Programmable Completion Builtins380173
-Node: A Programmable Completion Example390868
-Node: Using History Interactively396115
-Node: Bash History Facilities396799
-Node: Bash History Builtins399804
-Node: History Interaction404335
-Node: Event Designators407955
-Node: Word Designators409309
-Node: Modifiers411069
-Node: Installing Bash412880
-Node: Basic Installation414017
-Node: Compilers and Options417275
-Node: Compiling For Multiple Architectures418016
-Node: Installation Names419709
-Node: Specifying the System Type420527
-Node: Sharing Defaults421243
-Node: Operation Controls421916
-Node: Optional Features422874
-Node: Reporting Bugs433392
-Node: Major Differences From The Bourne Shell434586
-Node: GNU Free Documentation License451438
-Node: Indexes476615
-Node: Builtin Index477069
-Node: Reserved Word Index483896
-Node: Variable Index486344
-Node: Function Index502168
-Node: Concept Index515607
+Node: Bash Builtins146978
+Node: Modifying Shell Behavior175903
+Node: The Set Builtin176248
+Node: The Shopt Builtin186661
+Node: Special Builtins204331
+Node: Shell Variables205310
+Node: Bourne Shell Variables205747
+Node: Bash Variables207851
+Node: Bash Features239793
+Node: Invoking Bash240692
+Node: Bash Startup Files246705
+Node: Interactive Shells251808
+Node: What is an Interactive Shell?252218
+Node: Is this Shell Interactive?252867
+Node: Interactive Shell Behavior253682
+Node: Bash Conditional Expressions257169
+Node: Shell Arithmetic261746
+Node: Aliases264686
+Node: Arrays267306
+Node: The Directory Stack272671
+Node: Directory Stack Builtins273455
+Node: Controlling the Prompt276423
+Node: The Restricted Shell279344
+Node: Bash POSIX Mode281826
+Node: Job Control292759
+Node: Job Control Basics293219
+Node: Job Control Builtins298183
+Node: Job Control Variables303329
+Node: Command Line Editing304485
+Node: Introduction and Notation306156
+Node: Readline Interaction307779
+Node: Readline Bare Essentials308970
+Node: Readline Movement Commands310753
+Node: Readline Killing Commands311713
+Node: Readline Arguments313631
+Node: Searching314675
+Node: Readline Init File316861
+Node: Readline Init File Syntax318120
+Node: Conditional Init Constructs338650
+Node: Sample Init File342846
+Node: Bindable Readline Commands345963
+Node: Commands For Moving347167
+Node: Commands For History349026
+Node: Commands For Text353321
+Node: Commands For Killing356709
+Node: Numeric Arguments359524
+Node: Commands For Completion360663
+Node: Keyboard Macros364854
+Node: Miscellaneous Commands365541
+Node: Readline vi Mode371494
+Node: Programmable Completion372401
+Node: Programmable Completion Builtins380181
+Node: A Programmable Completion Example390876
+Node: Using History Interactively396123
+Node: Bash History Facilities396807
+Node: Bash History Builtins399812
+Node: History Interaction404344
+Node: Event Designators407964
+Node: Word Designators409318
+Node: Modifiers411078
+Node: Installing Bash412889
+Node: Basic Installation414026
+Node: Compilers and Options417284
+Node: Compiling For Multiple Architectures418025
+Node: Installation Names419718
+Node: Specifying the System Type420536
+Node: Sharing Defaults421252
+Node: Operation Controls421925
+Node: Optional Features422883
+Node: Reporting Bugs433401
+Node: Major Differences From The Bourne Shell434595
+Node: GNU Free Documentation License451447
+Node: Indexes476624
+Node: Builtin Index477078
+Node: Reserved Word Index483905
+Node: Variable Index486353
+Node: Function Index502177
+Node: Concept Index515616
 
 End Tag Table
 
diff --git a/doc/bash.ps b/doc/bash.ps
index 5a6d9cba..33af6747 100644
--- a/doc/bash.ps
+++ b/doc/bash.ps
@@ -1,6 +1,6 @@
 %!PS-Adobe-3.0
 %%Creator: groff version 1.22.4
-%%CreationDate: Tue Nov 26 11:15:40 2019
+%%CreationDate: Mon Jan  6 08:53:34 2020
 %%DocumentNeededResources: font Times-Roman
 %%+ font Times-Bold
 %%+ font Times-Italic
@@ -9640,37 +9640,36 @@ F0 .404(option is supplied, and)2.904 F F2(name)2.904 E F0 .404(is a v)
 .72(rather than the v)144 427.2 R .72(ariable it references.)-.25 F F1
 <ad6e>5.72 E F0 .72(has no ef)3.22 F .719(fect if the)-.25 F F1<ad66>
 3.219 E F0 .719(option is supplied.)3.219 F .719(If no options)5.719 F
-.189(are supplied, each)144 439.2 R F2(name)2.689 E F0 .189
-(refers to a v)2.689 F .189(ariable; if there is no v)-.25 F .19
-(ariable by that name, an)-.25 F 2.69(yf)-.15 G .19(unction with)-2.69 F
-1.116(that name is unset.)144 451.2 R 1.116(Each unset v)6.116 F 1.115
-(ariable or function is remo)-.25 F -.15(ve)-.15 G 3.615(df).15 G 1.115
-(rom the en)-3.615 F 1.115(vironment passed to)-.4 F 1.5
-(subsequent commands.)144 463.2 R 1.501(If an)6.5 F 4.001(yo)-.15 G(f)
--4.001 E/F3 9/Times-Bold@0 SF -.27(BA)4.001 G(SH_ALIASES).27 E/F4 9
-/Times-Roman@0 SF(,)A F3 -.27(BA)3.751 G(SH_ARGV0).27 E F4(,)A F3 -.27
-(BA)3.751 G(SH_CMDS).27 E F4(,)A F3 -.27(BA)3.751 G(SH_COM-).27 E(MAND)
-144 475.2 Q F4(,)A F3 -.27(BA)2.846 G(SH_SUBSHELL).27 E F4(,)A F3 -.27
-(BA)2.846 G(SHPID).27 E F4(,)A F3(COMP_W)2.846 E(ORDBREAKS)-.09 E F4(,)A
-F3(DIRST)2.846 E -.495(AC)-.81 G(K).495 E F4(,)A F3(EPOCHREAL)2.845 E
-(TIME)-.828 E F4(,)A F3(EPOCHSECONDS)144 487.2 Q F4(,)A F3(FUNCN)6.48 E
-(AME)-.18 E F4(,)A F3(GR)6.48 E(OUPS)-.27 E F4(,)A F3(HISTCMD)6.48 E F4
-(,)A F3(LINENO)6.481 E F4(,)A F3(RANDOM)6.481 E F4(,)A F3(SECONDS)6.481
-E F4(,)A F0(or)6.481 E F3(SRANDOM)144 499.2 Q F0 .832(are unset, the)
-3.082 F 3.332(yl)-.15 G .832(ose their special properties, e)-3.332 F
--.15(ve)-.25 G 3.332(ni).15 G 3.332(ft)-3.332 G(he)-3.332 E 3.332(ya)
--.15 G .832(re subsequently reset.)-3.332 F(The)5.831 E -.15(ex)144
-511.2 S(it status is true unless a).15 E F2(name)2.86 E F0(is readonly)
-2.68 E(.)-.65 E F1(wait)108 528 Q F0([)2.5 E F1(\255fn)A F0 2.5(][)C F1
-<ad70>-2.5 E F2(varname)2.5 E F0 2.5(][)C F2(id ...)-2.5 E F0(])A -.8
-(Wa)144 540 S .659(it for each speci\214ed child process and return its\
- termination status.).8 F(Each)5.659 E F2(id)3.169 E F0 .659
-(may be a process)3.929 F .009
-(ID or a job speci\214cation; if a job spec is gi)144 552 R -.15(ve)-.25
-G .008(n, all processes in that job').15 F 2.508(sp)-.55 G .008
-(ipeline are w)-2.508 F .008(aited for)-.1 F 5.008(.I)-.55 G(f)-5.008 E
-F2(id)144.01 564 Q F0 .441(is not gi)3.711 F -.15(ve)-.25 G(n,).15 E F1
-(wait)2.941 E F0 -.1(wa)2.941 G .441
+.736(are supplied, each)144 439.2 R F2(name)3.236 E F0 .736
+(refers to a v)3.236 F .737(ariable; if there is no v)-.25 F .737
+(ariable by that name, a function with)-.25 F 1.762(that name, if an)144
+451.2 R 3.062 -.65(y, i)-.15 H 4.262(su).65 G 4.261(nset. Each)-4.262 F
+1.761(unset v)4.261 F 1.761(ariable or function is remo)-.25 F -.15(ve)
+-.15 G 4.261(df).15 G 1.761(rom the en)-4.261 F(vironment)-.4 E 3.171
+(passed to subsequent commands.)144 463.2 R 3.172(If an)8.172 F 5.672
+(yo)-.15 G(f)-5.672 E/F3 9/Times-Bold@0 SF -.27(BA)5.672 G(SH_ALIASES)
+.27 E/F4 9/Times-Roman@0 SF(,)A F3 -.27(BA)5.422 G(SH_ARGV0).27 E F4(,)A
+F3 -.27(BA)5.422 G(SH_CMDS).27 E F4(,)A F3 -.27(BA)144 475.2 S
+(SH_COMMAND).27 E F4(,)A F3 -.27(BA)11.482 G(SH_SUBSHELL).27 E F4(,)A F3
+-.27(BA)11.482 G(SHPID).27 E F4(,)A F3(COMP_W)11.482 E(ORDBREAKS)-.09 E
+F4(,)A F3(DIRST)11.481 E -.495(AC)-.81 G(K).495 E F4(,)A F3(EPOCHREAL)
+144 487.2 Q(TIME)-.828 E F4(,)A F3(EPOCHSECONDS)2.67 E F4(,)A F3(FUNCN)
+2.67 E(AME)-.18 E F4(,)A F3(GR)2.67 E(OUPS)-.27 E F4(,)A F3(HISTCMD)2.67
+E F4(,)A F3(LINENO)2.67 E F4(,)A F3(RANDOM)2.67 E F4(,)A F3(SECONDS)144
+499.2 Q F4(,)A F0(or)4.03 E F3(SRANDOM)4.28 E F0 1.779(are unset, the)
+4.03 F 4.279(yl)-.15 G 1.779(ose their special properties, e)-4.279 F
+-.15(ve)-.25 G 4.279(ni).15 G 4.279(ft)-4.279 G(he)-4.279 E 4.279(ya)
+-.15 G 1.779(re subse-)-4.279 F(quently reset.)144 511.2 Q(The e)5 E
+(xit status is true unless a)-.15 E F2(name)2.86 E F0(is readonly)2.68 E
+(.)-.65 E F1(wait)108 528 Q F0([)2.5 E F1(\255fn)A F0 2.5(][)C F1<ad70>
+-2.5 E F2(varname)2.5 E F0 2.5(][)C F2(id ...)-2.5 E F0(])A -.8(Wa)144
+540 S .659(it for each speci\214ed child process and return its termina\
+tion status.).8 F(Each)5.659 E F2(id)3.169 E F0 .659(may be a process)
+3.929 F .009(ID or a job speci\214cation; if a job spec is gi)144 552 R
+-.15(ve)-.25 G .008(n, all processes in that job').15 F 2.508(sp)-.55 G
+.008(ipeline are w)-2.508 F .008(aited for)-.1 F 5.008(.I)-.55 G(f)
+-5.008 E F2(id)144.01 564 Q F0 .441(is not gi)3.711 F -.15(ve)-.25 G(n,)
+.15 E F1(wait)2.941 E F0 -.1(wa)2.941 G .441
 (its for all running background jobs and the last-e).1 F -.15(xe)-.15 G
 .442(cuted process substitu-).15 F .598
 (tion, if its process id is the same as)144 576 R F1($!)3.098 E F0 3.098
diff --git a/doc/bashref.aux b/doc/bashref.aux
index 59572fde..34cffe01 100644
--- a/doc/bashref.aux
+++ b/doc/bashref.aux
@@ -162,7 +162,7 @@
 @xrdef{The Shopt Builtin-pg}{66}
 @xrdef{Special Builtins-title}{Special Builtins}
 @xrdef{Special Builtins-snt}{Section@tie 4.4}
-@xrdef{Special Builtins-pg}{72}
+@xrdef{Special Builtins-pg}{73}
 @xrdef{Shell Variables-title}{Shell Variables}
 @xrdef{Shell Variables-snt}{Chapter@tie 5}
 @xrdef{Bourne Shell Variables-title}{Bourne Shell Variables}
diff --git a/doc/bashref.bt b/doc/bashref.bt
index 725ea2c2..1dc47c58 100644
--- a/doc/bashref.bt
+++ b/doc/bashref.bt
@@ -29,7 +29,7 @@
 \entry{enable}{56}{\code {enable}}
 \entry{help}{56}{\code {help}}
 \entry{let}{56}{\code {let}}
-\entry{local}{56}{\code {local}}
+\entry{local}{57}{\code {local}}
 \entry{logout}{57}{\code {logout}}
 \entry{mapfile}{57}{\code {mapfile}}
 \entry{printf}{57}{\code {printf}}
@@ -38,7 +38,7 @@
 \entry{source}{60}{\code {source}}
 \entry{type}{60}{\code {type}}
 \entry{typeset}{60}{\code {typeset}}
-\entry{ulimit}{60}{\code {ulimit}}
+\entry{ulimit}{61}{\code {ulimit}}
 \entry{unalias}{62}{\code {unalias}}
 \entry{set}{62}{\code {set}}
 \entry{shopt}{66}{\code {shopt}}
diff --git a/doc/bashref.bts b/doc/bashref.bts
index b920ac06..0accde84 100644
--- a/doc/bashref.bts
+++ b/doc/bashref.bts
@@ -45,7 +45,7 @@
 \entry{\code {kill}}{107}
 \initial {L}
 \entry{\code {let}}{56}
-\entry{\code {local}}{56}
+\entry{\code {local}}{57}
 \entry{\code {logout}}{57}
 \initial {M}
 \entry{\code {mapfile}}{57}
@@ -72,7 +72,7 @@
 \entry{\code {type}}{60}
 \entry{\code {typeset}}{60}
 \initial {U}
-\entry{\code {ulimit}}{60}
+\entry{\code {ulimit}}{61}
 \entry{\code {umask}}{51}
 \entry{\code {unalias}}{62}
 \entry{\code {unset}}{51}
diff --git a/doc/bashref.cp b/doc/bashref.cp
index 768b26e4..bd395b51 100644
--- a/doc/bashref.cp
+++ b/doc/bashref.cp
@@ -71,7 +71,7 @@
 \entry{exit status}{41}{exit status}
 \entry{signal handling}{41}{signal handling}
 \entry{shell script}{42}{shell script}
-\entry{special builtin}{72}{special builtin}
+\entry{special builtin}{73}{special builtin}
 \entry{login shell}{88}{login shell}
 \entry{interactive shell}{88}{interactive shell}
 \entry{startup files}{88}{startup files}
diff --git a/doc/bashref.cps b/doc/bashref.cps
index 83f677f1..2e8a197a 100644
--- a/doc/bashref.cps
+++ b/doc/bashref.cps
@@ -119,7 +119,7 @@
 \entry{shell, interactive}{89}
 \entry{signal}{4}
 \entry{signal handling}{41}
-\entry{special builtin}{4, 72}
+\entry{special builtin}{4, 73}
 \entry{startup files}{88}
 \entry{suspending jobs}{105}
 \initial {T}
diff --git a/doc/bashref.info b/doc/bashref.info
index 7828c0cc..d097e5a9 100644
--- a/doc/bashref.info
+++ b/doc/bashref.info
@@ -3332,9 +3332,9 @@ standard.
      attribute, NAME will be unset rather than the variable it
      references.  '-n' has no effect if the '-f' option is supplied.  If
      no options are supplied, each NAME refers to a variable; if there
-     is no variable by that name, any function with that name is unset.
-     Readonly variables and functions may not be unset.  Some shell
-     variables lose their special behavior if they are unset; such
+     is no variable by that name, a function with that name, if any, is
+     unset.  Readonly variables and functions may not be unset.  Some
+     shell variables lose their special behavior if they are unset; such
      behavior is noted in the description of the individual variables.
      The return status is zero unless a NAME is readonly.
 
@@ -3884,7 +3884,7 @@ standard.
           from regular files.  If 'read' times out, 'read' saves any
           partial input read into the specified variable NAME.  If
           TIMEOUT is 0, 'read' returns immediately, without trying to
-          read and data.  The exit status is 0 if input is available on
+          read any data.  The exit status is 0 if input is available on
           the specified file descriptor, non-zero otherwise.  The exit
           status is greater than 128 if the timeout is exceeded.
 
@@ -9335,7 +9335,7 @@ history file.
 
      In the second form, COMMAND is re-executed after each instance of
      PAT in the selected command is replaced by REP.  COMMAND is
-     intepreted the same as FIRST above.
+     interpreted the same as FIRST above.
 
      A useful alias to use with the 'fc' command is 'r='fc -s'', so that
      typing 'r cc' runs the last command beginning with 'cc' and typing
@@ -11822,84 +11822,84 @@ Node: Signals119037
 Node: Shell Scripts121004
 Node: Shell Builtin Commands124016
 Node: Bourne Shell Builtins126054
-Node: Bash Builtins146970
-Node: Modifying Shell Behavior175895
-Node: The Set Builtin176240
-Node: The Shopt Builtin186653
-Node: Special Builtins204323
-Node: Shell Variables205302
-Node: Bourne Shell Variables205739
-Node: Bash Variables207843
-Node: Bash Features239785
-Node: Invoking Bash240684
-Node: Bash Startup Files246697
-Node: Interactive Shells251800
-Node: What is an Interactive Shell?252210
-Node: Is this Shell Interactive?252859
-Node: Interactive Shell Behavior253674
-Node: Bash Conditional Expressions257161
-Node: Shell Arithmetic261738
-Node: Aliases264678
-Node: Arrays267298
-Node: The Directory Stack272663
-Node: Directory Stack Builtins273447
-Node: Controlling the Prompt276415
-Node: The Restricted Shell279336
-Node: Bash POSIX Mode281818
-Node: Job Control292751
-Node: Job Control Basics293211
-Node: Job Control Builtins298175
-Node: Job Control Variables303321
-Node: Command Line Editing304477
-Node: Introduction and Notation306148
-Node: Readline Interaction307771
-Node: Readline Bare Essentials308962
-Node: Readline Movement Commands310745
-Node: Readline Killing Commands311705
-Node: Readline Arguments313623
-Node: Searching314667
-Node: Readline Init File316853
-Node: Readline Init File Syntax318112
-Node: Conditional Init Constructs338642
-Node: Sample Init File342838
-Node: Bindable Readline Commands345955
-Node: Commands For Moving347159
-Node: Commands For History349018
-Node: Commands For Text353313
-Node: Commands For Killing356701
-Node: Numeric Arguments359516
-Node: Commands For Completion360655
-Node: Keyboard Macros364846
-Node: Miscellaneous Commands365533
-Node: Readline vi Mode371486
-Node: Programmable Completion372393
-Node: Programmable Completion Builtins380173
-Node: A Programmable Completion Example390868
-Node: Using History Interactively396115
-Node: Bash History Facilities396799
-Node: Bash History Builtins399804
-Node: History Interaction404335
-Node: Event Designators407955
-Node: Word Designators409309
-Node: Modifiers411069
-Node: Installing Bash412880
-Node: Basic Installation414017
-Node: Compilers and Options417275
-Node: Compiling For Multiple Architectures418016
-Node: Installation Names419709
-Node: Specifying the System Type420527
-Node: Sharing Defaults421243
-Node: Operation Controls421916
-Node: Optional Features422874
-Node: Reporting Bugs433392
-Node: Major Differences From The Bourne Shell434586
-Node: GNU Free Documentation License451438
-Node: Indexes476615
-Node: Builtin Index477069
-Node: Reserved Word Index483896
-Node: Variable Index486344
-Node: Function Index502168
-Node: Concept Index515607
+Node: Bash Builtins146978
+Node: Modifying Shell Behavior175903
+Node: The Set Builtin176248
+Node: The Shopt Builtin186661
+Node: Special Builtins204331
+Node: Shell Variables205310
+Node: Bourne Shell Variables205747
+Node: Bash Variables207851
+Node: Bash Features239793
+Node: Invoking Bash240692
+Node: Bash Startup Files246705
+Node: Interactive Shells251808
+Node: What is an Interactive Shell?252218
+Node: Is this Shell Interactive?252867
+Node: Interactive Shell Behavior253682
+Node: Bash Conditional Expressions257169
+Node: Shell Arithmetic261746
+Node: Aliases264686
+Node: Arrays267306
+Node: The Directory Stack272671
+Node: Directory Stack Builtins273455
+Node: Controlling the Prompt276423
+Node: The Restricted Shell279344
+Node: Bash POSIX Mode281826
+Node: Job Control292759
+Node: Job Control Basics293219
+Node: Job Control Builtins298183
+Node: Job Control Variables303329
+Node: Command Line Editing304485
+Node: Introduction and Notation306156
+Node: Readline Interaction307779
+Node: Readline Bare Essentials308970
+Node: Readline Movement Commands310753
+Node: Readline Killing Commands311713
+Node: Readline Arguments313631
+Node: Searching314675
+Node: Readline Init File316861
+Node: Readline Init File Syntax318120
+Node: Conditional Init Constructs338650
+Node: Sample Init File342846
+Node: Bindable Readline Commands345963
+Node: Commands For Moving347167
+Node: Commands For History349026
+Node: Commands For Text353321
+Node: Commands For Killing356709
+Node: Numeric Arguments359524
+Node: Commands For Completion360663
+Node: Keyboard Macros364854
+Node: Miscellaneous Commands365541
+Node: Readline vi Mode371494
+Node: Programmable Completion372401
+Node: Programmable Completion Builtins380181
+Node: A Programmable Completion Example390876
+Node: Using History Interactively396123
+Node: Bash History Facilities396807
+Node: Bash History Builtins399812
+Node: History Interaction404344
+Node: Event Designators407964
+Node: Word Designators409318
+Node: Modifiers411078
+Node: Installing Bash412889
+Node: Basic Installation414026
+Node: Compilers and Options417284
+Node: Compiling For Multiple Architectures418025
+Node: Installation Names419718
+Node: Specifying the System Type420536
+Node: Sharing Defaults421252
+Node: Operation Controls421925
+Node: Optional Features422883
+Node: Reporting Bugs433401
+Node: Major Differences From The Bourne Shell434595
+Node: GNU Free Documentation License451447
+Node: Indexes476624
+Node: Builtin Index477078
+Node: Reserved Word Index483905
+Node: Variable Index486353
+Node: Function Index502177
+Node: Concept Index515616
 
 End Tag Table
 
diff --git a/doc/bashref.ps b/doc/bashref.ps
index 670d03c4..dded7b4b 100644
--- a/doc/bashref.ps
+++ b/doc/bashref.ps
@@ -1,7 +1,7 @@
 %!PS-Adobe-2.0
 %%Creator: dvips(k) 5.999 Copyright 2019 Radical Eye Software
 %%Title: bashref.dvi
-%%CreationDate: Tue Nov 26 16:18:24 2019
+%%CreationDate: Mon Jan  6 13:53:44 2020
 %%Pages: 187
 %%PageOrder: Ascend
 %%BoundingBox: 0 0 612 792
@@ -12,7 +12,7 @@
 %DVIPSWebPage: (www.radicaleye.com)
 %DVIPSCommandLine: dvips -D 600 -t letter -o bashref.ps bashref.dvi
 %DVIPSParameters: dpi=600
-%DVIPSSource:  TeX output 2019.11.26:1118
+%DVIPSSource:  TeX output 2020.01.06:0853
 %%BeginProcSet: tex.pro 0 0
 %!
 /TeXDict 300 dict def TeXDict begin/N{def}def/B{bind def}N/S{exch}N/X{S
@@ -7886,7 +7886,7 @@ h(:)f(:)h(:)f(:)g(:)h(:)34 b Fu(66)275 2882 y(4.4)92
 b(Sp)s(ecial)30 b(Builtins)9 b Fn(:)16 b(:)f(:)h(:)f(:)g(:)h(:)f(:)h(:)
 f(:)g(:)h(:)f(:)h(:)f(:)g(:)h(:)f(:)h(:)f(:)g(:)h(:)f(:)h(:)f(:)g(:)h
 (:)f(:)h(:)f(:)g(:)h(:)f(:)h(:)f(:)g(:)h(:)f(:)h(:)f(:)g(:)h(:)f(:)h(:)
-f(:)g(:)h(:)f(:)22 b Fu(72)150 3132 y Fs(5)135 b(Shell)45
+f(:)g(:)h(:)f(:)22 b Fu(73)150 3132 y Fs(5)135 b(Shell)45
 b(V)-11 b(ariables)11 b Fo(:)20 b(:)g(:)f(:)g(:)h(:)f(:)h(:)f(:)h(:)f
 (:)h(:)f(:)g(:)h(:)f(:)h(:)f(:)h(:)f(:)h(:)f(:)g(:)h(:)f(:)h(:)f(:)h(:)
 f(:)h(:)f(:)g(:)h(:)f(:)24 b Fs(74)275 3269 y Fu(5.1)92
@@ -9326,7 +9326,7 @@ Fm(posix)f Fu(mo)s(de)h(\(see)i(Section)f(6.11)h([Bash)e(POSIX)g(Mo)s
 1933 y(v)-5 b(alid)37 b(shell)f Fr(name)42 b Fu(and)36
 b(ma)m(y)h(not)f(b)s(e)g(the)g(same)h(as)g(one)f(of)h(the)g(sp)s(ecial)
 g(builtins)e(\(see)j(Section)f(4.4)150 2042 y([Sp)s(ecial)e(Builtins],)
-h(page)e(72\).)54 b(In)33 b(default)h(mo)s(de,)h(a)g(function)f(name)g
+h(page)e(73\).)54 b(In)33 b(default)h(mo)s(de,)h(a)g(function)f(name)g
 (can)g(b)s(e)g(an)m(y)g(unquoted)g(shell)150 2152 y(w)m(ord)g(that)h
 (do)s(es)e(not)i(con)m(tain)g(`)p Ft($)p Fu('.)53 b(An)m(y)34
 b(redirections)h(\(see)g(Section)g(3.6)g([Redirections],)i(page)e(34\))
diff --git a/doc/bashref.ps b/doc/bashref.ps
index 670d03c4..dded7b4b 100644
--- a/doc/bashref.ps
+++ b/doc/bashref.ps
@@ -18398,10 +18389,10 @@ e Ft(vi)f Fu(if)h(neither)g(is)g(set.)66 b(When)39 b(editing)g(is)g
 (complete,)k(the)630 2086 y(edited)31 b(commands)f(are)g(ec)m(ho)s(ed)h
 (and)f(executed.)630 2212 y(In)k(the)g(second)g(form,)h
 Fr(command)j Fu(is)c(re-executed)i(after)f(eac)m(h)g(instance)g(of)f
-Fr(pat)j Fu(in)d(the)630 2322 y(selected)e(command)e(is)h(replaced)g(b)
-m(y)f Fr(rep)p Fu(.)41 b Fr(command)34 b Fu(is)c(in)m(tepreted)h(the)g
-(same)g(as)g Fr(\014rst)630 2432 y Fu(ab)s(o)m(v)m(e.)630
-2558 y(A)g(useful)f(alias)i(to)g(use)e(with)h(the)g Ft(fc)f
+Fr(pat)j Fu(in)d(the)630 2322 y(selected)29 b(command)e(is)h(replaced)f
+(b)m(y)h Fr(rep)p Fu(.)39 b Fr(command)31 b Fu(is)c(in)m(terpreted)h
+(the)f(same)h(as)g Fr(\014rst)630 2432 y Fu(ab)s(o)m(v)m(e.)630
+2558 y(A)j(useful)f(alias)i(to)g(use)e(with)h(the)g Ft(fc)f
 Fu(command)h(is)g Ft(r='fc)e(-s')p Fu(,)h(so)h(that)h(t)m(yping)f(`)p
 Ft(r)f(cc)p Fu(')630 2668 y(runs)35 b(the)h(last)h(command)f(b)s
 (eginning)g(with)g Ft(cc)f Fu(and)h(t)m(yping)g(`)p Ft(r)p
@@ -20478,7 +20469,7 @@ g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g
 g(:)g(:)h(:)f(:)28 b Fb(56)2025 2760 y Fe(local)9 b Fc(:)14
 b(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g
 (:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)
-g(:)g(:)g(:)h(:)f(:)g(:)23 b Fb(56)2025 2848 y Fe(logout)6
+g(:)g(:)g(:)h(:)f(:)g(:)23 b Fb(57)2025 2848 y Fe(logout)6
 b Fc(:)14 b(:)f(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g
 (:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)
 h(:)f(:)g(:)g(:)g(:)g(:)g(:)21 b Fb(57)2021 3110 y Fs(M)2025
@@ -20546,7 +20537,7 @@ g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h
 b Fb(60)146 1003 y Fs(U)150 1119 y Fe(ulimit)6 b Fc(:)15
 b(:)e(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f
 (:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)
-g(:)g(:)g(:)h(:)f(:)20 b Fb(60)150 1206 y Fe(umask)9
+g(:)g(:)g(:)h(:)f(:)20 b Fb(61)150 1206 y Fe(umask)9
 b Fc(:)14 b(:)f(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g
 (:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)
 g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)23 b Fb(51)150 1293 y
@@ -21671,7 +21662,7 @@ b(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g
 (:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)21
 b Fb(41)2025 1077 y(sp)r(ecial)27 b(builtin)16 b Fc(:)d(:)g(:)g(:)g(:)g
 (:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)
-g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)31 b Fb(4,)26 b(72)2025
+g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)31 b Fb(4,)26 b(73)2025
 1170 y(startup)f(\014les)10 b Fc(:)k(:)f(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)
 g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g
 (:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)25 b Fb(88)2025 1257
diff --git a/doc/bashref.toc b/doc/bashref.toc
index 883c755d..27cbee83 100644
--- a/doc/bashref.toc
+++ b/doc/bashref.toc
@@ -62,7 +62,7 @@
 @numsecentry{Modifying Shell Behavior}{4.3}{Modifying Shell Behavior}{62}
 @numsubsecentry{The Set Builtin}{4.3.1}{The Set Builtin}{62}
 @numsubsecentry{The Shopt Builtin}{4.3.2}{The Shopt Builtin}{66}
-@numsecentry{Special Builtins}{4.4}{Special Builtins}{72}
+@numsecentry{Special Builtins}{4.4}{Special Builtins}{73}
 @numchapentry{Shell Variables}{5}{Shell Variables}{74}
 @numsecentry{Bourne Shell Variables}{5.1}{Bourne Shell Variables}{74}
 @numsecentry{Bash Variables}{5.2}{Bash Variables}{74}
diff --git a/doc/builtins.0 b/doc/builtins.0
index 67b5bbf8..c3d01fc6 100644
--- a/doc/builtins.0
+++ b/doc/builtins.0
@@ -1823,8 +1823,8 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
               _n_a_m_e will be unset rather than the variable it  references.   --nn
               has  no  effect if the --ff option is supplied.  If no options are
               supplied, each _n_a_m_e refers to a variable; if there is  no  vari-
-              able  by  that name, any function with that name is unset.  Each
-              unset variable or  function  is  removed  from  the  environment
+              able  by that name, a function with that name, if any, is unset.
+              Each unset variable or function is removed from the  environment
               passed   to   subsequent  commands.   If  any  of  BBAASSHH__AALLIIAASSEESS,
               BBAASSHH__AARRGGVV00,  BBAASSHH__CCMMDDSS,  BBAASSHH__CCOOMMMMAANNDD,  BBAASSHH__SSUUBBSSHHEELLLL,  BBAASSHHPPIIDD,
               CCOOMMPP__WWOORRDDBBRREEAAKKSS,  DDIIRRSSTTAACCKK,  EEPPOOCCHHRREEAALLTTIIMMEE,  EEPPOOCCHHSSEECCOONNDDSS, FFUUNNCC--
